%define	major		0
%define	majorpp		2
%define libname		%mklibname %{name} %{major}
%define develname	%mklibname %{name} -d

%define majorver	1
%define minorver	28
%define patchver	1

%define gendersplusplus_libname	%mklibname gendersplusplus %{majorpp}

Summary:	Static cluster configuration database
Name:		genders
Version:	%{majorver}.%{minorver}.%{patchver}
Release:	%mkrel 1
Group:		System/Libraries
License:	GPLv2
URL:		https://github.com/chaos/genders
Source0:	https://github.com/chaos/genders/archive/genders-%{majorver}-%{minorver}-%{patchver}.tar.gz
Patch0:		genders-1.18-shebang.patch
BuildRequires:	byacc
BuildRequires:	flex
BuildRequires:	libtool

%description
Genders is a static cluster configuration database used for cluster
configuration management.  It is used by a variety of tools and scripts for
management of large clusters.  The genders database is typically replicated
on every node of the cluster. It describes the layout and configuration of
the cluster so that tools and scripts can sense the variations of cluster
nodes. By abstracting this information into a plain text file, it becomes
possible to change the configuration of a cluster by modifying only one file.

%package -n	%{libname}
Summary:	Static cluster configuration database library
Group:          System/Libraries

%description -n	%{libname}
Genders is a static cluster configuration database used for cluster
configuration management.  It is used by a variety of tools and scripts for
management of large clusters.  The genders database is typically replicated
on every node of the cluster. It describes the layout and configuration of
the cluster so that tools and scripts can sense the variations of cluster
nodes. By abstracting this information into a plain text file, it becomes
possible to change the configuration of a cluster by modifying only one file.

%package -n	%{gendersplusplus_libname}
Summary:	Static cluster configuration database C++ library
Group:          System/Libraries

%description -n	%{gendersplusplus_libname}
Genders is a static cluster configuration database used for cluster
configuration management.  It is used by a variety of tools and scripts for
management of large clusters.  The genders database is typically replicated
on every node of the cluster. It describes the layout and configuration of
the cluster so that tools and scripts can sense the variations of cluster
nodes. By abstracting this information into a plain text file, it becomes
possible to change the configuration of a cluster by modifying only one file.

This package contains the C++ bindings for genders.


%package -n	%{develname}
Summary:	Static library and header files for the genders library
Group:		Development/C
Provides:	%{name}-devel = %{version}
Provides:	lib%{name}-devel = %{version}
Requires:	%{libname} = %{version}
Requires:	%{gendersplusplus_libname} = %{version}

%description -n	%{develname}
Genders is a static cluster configuration database used for cluster
configuration management.  It is used by a variety of tools and scripts for
management of large clusters.  The genders database is typically replicated
on every node of the cluster. It describes the layout and configuration of
the cluster so that tools and scripts can sense the variations of cluster
nodes. By abstracting this information into a plain text file, it becomes
possible to change the configuration of a cluster by modifying only one file.

This package contains the static genders library and its header files.

%package	compat
Summary:	Compatability library
Group:		System/Libraries

%description	compat
genders API that is compatible with earlier releases of genders.

%package -n	perl-Libgenders
Summary:	Genders interface
Group:		Development/Perl
BuildRequires:	perl-devel
Provides:	perl-Genders = %{version}
Obsoletes:	perl-Genders

%description -n	perl-Libgenders
This package provides a perl interface for querying a genders file.

%package -n	python3-libgenders
Summary:	Genders interface
Group:		Development/Python
BuildRequires:	pkgconfig(python3)

Obsoletes:	python-libgenders < 1.22-10
Provides:	python-libgenders = %{version}-%{release}

%description -n	python3-libgenders
This package provides a python3 interface for querying a genders file.

%package	java
Summary:	Java libraries
Group:		Development/Java
BuildRequires:	java-devel

%description	java
Genders API bindings for java.

%package	java-devel
Summary:	Java Development libraries
Group:		Development/Java
Requires:	%{name}-java = %{version}-%{release}

%description	java-devel
Genders API bindings for java.

%package	javadoc
Summary:	Java Documentation
Group:		Documentation
BuildRequires:	java-devel

%description	javadoc
Genders API Documentation for java.

%prep
%setup -q -n %{name}-%{name}-%{majorver}-%{minorver}-%{patchver}
%autopatch -p1

%build
# fix build on aarch64
autoreconf -vfi -Iconfig

export CPPFLAGS='-I/usr/lib/jvm/java/include -I/usr/lib/jvm/java/include/linux -I../../../src/libgenders'
export PYTHON=%{__python3}
%configure \
	--disable-static \
	--with-genders-file=%{_sysconfdir}/%{name} \
	--with-perl-extensions \
	--with-perl-vendor-arch \
	--with-python-extensions \
	--with-cplusplus-extensions \
	--with-extension-destdir=%{buildroot}

make LD_RUN_PATH=""

%install
install -d %{buildroot}%{_sysconfdir}

%make_install LD_RUN_PATH=""

install -m0644 genders.sample %{buildroot}%{_sysconfdir}/%{name}

mkdir -p %{buildroot}%{_jnidir}
mv %{buildroot}%{_datadir}/java/Genders.jar %{buildroot}/%{_jnidir}/

# we don't want these
find %{buildroot} -name '*.la' -delete

%files
%doc README NEWS ChangeLog DISCLAIMER DISCLAIMER.UC COPYING TUTORIAL
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/%{name}
%{_bindir}/*
%{_mandir}/man1/*
%{_mandir}/man3/genders.3*

%files -n %{libname}
%doc DISCLAIMER DISCLAIMER.UC COPYING
%{_libdir}/libgenders.so.%{major}
%{_libdir}/libgenders.so.%{major}.*
%{_mandir}/man3/libgenders.3*

%files -n %{gendersplusplus_libname}
%doc DISCLAIMER DISCLAIMER.UC COPYING
%{_libdir}/libgendersplusplus.so.%{majorpp}
%{_libdir}/libgendersplusplus.so.%{majorpp}.*

%files -n %{develname}
%doc DISCLAIMER DISCLAIMER.UC COPYING
%{_includedir}/*
%{_libdir}/libgenders*.so
%{_mandir}/man3/genders_*

%files compat
%doc DISCLAIMER DISCLAIMER.UC COPYING
%{_mandir}/man3/gendlib*
%dir %{_prefix}/lib/genders
%{_prefix}/lib/genders/*

%files -n perl-Libgenders
%doc DISCLAIMER DISCLAIMER.UC COPYING
%{perl_vendorarch}/Genders.pm
%{perl_vendorarch}/Libgenders.pm
%dir %{perl_vendorarch}/auto/Libgenders
%{perl_vendorarch}/auto/Libgenders/Libgenders.so
%{_mandir}/man3/Genders.3pm*
%{_mandir}/man3/Libgenders.3pm*

%files -n python3-libgenders
%doc DISCLAIMER DISCLAIMER.UC COPYING
%{python3_sitearch}/genders.py*
%{python3_sitearch}/libgenders-*-py*.egg-info
%{python3_sitearch}/libgenders*.so
%{python3_sitearch}/__pycache__/*

%files java
%doc DISCLAIMER DISCLAIMER.UC COPYING
%{_libdir}/libGendersjni.so.*
%{_jnidir}/Genders.jar

%files java-devel
%doc DISCLAIMER DISCLAIMER.UC COPYING
%{_libdir}/libGendersjni.so

%files javadoc
%doc DISCLAIMER DISCLAIMER.UC COPYING
%{_docdir}/%{name}-%{majorver}.%{minorver}-javadoc


%changelog
* Tue Jul 14 2020 daviddavid <daviddavid> 1.28.1-1.mga8
+ Revision: 1606065
- new version: 1.28.1
+ umeabot <umeabot>
- Rebuild for perl 5.32

* Tue Feb 18 2020 umeabot <umeabot> 1.27.2-2.mga8
+ Revision: 1538312
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%configure2_5x

* Tue Nov 19 2019 daviddavid <daviddavid> 1.27.2-1.mga8
+ Revision: 1461736
- new version: 1.27.2
- update URL and Source URL
- port to python 3

* Tue Aug 27 2019 tmb <tmb> 1.22-9.mga8
+ Revision: 1433803
- rebuild for perl 5.30

* Sun Sep 23 2018 umeabot <umeabot> 1.22-8.mga7
+ Revision: 1297855
- Mageia 7 Mass Rebuild

* Mon Aug 06 2018 shlomif <shlomif> 1.22-7.mga7
+ Revision: 1248208
- Rebuild for new perl 5.28.0

* Thu Jun 07 2018 wally <wally> 1.22-6.mga7
+ Revision: 1235215
- fix build on aarch64
+ kekepower <kekepower>
- Use make_install

* Thu Aug 31 2017 pterjan <pterjan> 1.22-5.mga7
+ Revision: 1150260
- Rebuild for perl ABI changes

* Sat Jul 22 2017 neoclust <neoclust> 1.22-4.mga7
+ Revision: 1126668
- Rebuild against new Perl 5.26

* Sat Jun 18 2016 pterjan <pterjan> 1.22-3.mga6
+ Revision: 1022128
- Rebuild for perl 5.22.2

* Sun Feb 14 2016 umeabot <umeabot> 1.22-2.mga6
+ Revision: 960273
- Mageia 6 Mass Rebuild

* Sat Aug 08 2015 daviddavid <daviddavid> 1.22-1.mga6
+ Revision: 861650
- new version: 1.22
- now major is 2 for gendersplusplus library
- fix License
- enable -java, -java-devel and -javadoc subpackages
- add 2 patches from Fedora
  * genders-1.18-shebang.patch
  * genders-1.22-javadoc.patch
- genders-devel requires gendersplusplus library
- switch perl to vendor-arch instead of site-arch (fix Libgenders.3pm mandir path)
- disable static libraries
- replace /etc/genders file to the main package
- replace all man files with their appropriate subpackages

* Thu Jun 25 2015 sander85 <sander85> 1.20-9.mga6
+ Revision: 842750
- Rebuild for perl 5.22

* Wed Oct 15 2014 umeabot <umeabot> 1.20-8.mga5
+ Revision: 745952
- Second Mageia 5 Mass Rebuild

* Sat Sep 27 2014 tv <tv> 1.20-7.mga5
+ Revision: 726305
- rebuild for missing pythoneggs deps

* Tue Sep 16 2014 umeabot <umeabot> 1.20-6.mga5
+ Revision: 679488
- Mageia 5 Mass Rebuild

* Tue Jun 03 2014 pterjan <pterjan> 1.20-5.mga5
+ Revision: 630778
- Rebuild for perl 5.20

* Sat May 31 2014 pterjan <pterjan> 1.20-4.mga5
+ Revision: 628215
- Rebuild for new Python

* Tue Oct 22 2013 umeabot <umeabot> 1.20-3.mga4
+ Revision: 544892
- Mageia 4 Mass Rebuild

* Tue Oct 15 2013 pterjan <pterjan> 1.20-2.mga4
+ Revision: 500475
- Rebuild to add different pythonegg provides for python 2 and 3

* Sun Jun 09 2013 fwang <fwang> 1.20-1.mga4
+ Revision: 441050
- new version 1.20

* Wed May 29 2013 fwang <fwang> 1.18-4.mga4
+ Revision: 430391
- rebuild for new perl

* Fri Jan 11 2013 umeabot <umeabot> 1.18-3.mga3
+ Revision: 351304
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Wed May 30 2012 jquelin <jquelin> 1.18-2.mga3
+ Revision: 251545
- perl 5.16 rebuild

* Sun Sep 04 2011 fwang <fwang> 1.18-1.mga2
+ Revision: 138374
- sync with mandriva rpm
- fix install
- br python
- new version 1.18

* Sun Jun 12 2011 sander85 <sander85> 1.13-5.mga2
+ Revision: 104310
- Rebuild for perl 5.14

* Thu Mar 03 2011 ennael <ennael> 1.13-4.mga1
+ Revision: 63300
- clean spec file
- imported package genders


* Sun Aug 01 2010 Funda Wang <fwang@mandriva.org> 1.13-4mdv2011.0
+ Revision: 564237
- rebuild for perl 5.12.1

* Wed Jul 21 2010 Jérôme Quelin <jquelin@mandriva.org> 1.13-3mdv2011.0
+ Revision: 556349
- rebuild for perl 5.12

* Mon Mar 15 2010 Oden Eriksson <oeriksson@mandriva.com> 1.13-2mdv2010.1
+ Revision: 520113
- rebuilt for 2010.1

* Sun Jun 21 2009 Oden Eriksson <oeriksson@mandriva.com> 1.13-1mdv2010.0
+ Revision: 387849
- 1.13

* Thu Jan 29 2009 Oden Eriksson <oeriksson@mandriva.com> 1.11-1mdv2009.1
+ Revision: 335144
- fix deps
- import genders


* Thu Jan 29 2009 Oden Eriksson <oeriksson@mandriva.com> 1.11-1mdv2009.1
- initial Mandriva package
